#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include ".\Window\CMainWindow.h"
#include ".\Window\CSplashWindow.h"
#include ".\util\StrUtil.h"
#include "DigiTV.h"
#include "resource.h"

#ifdef _DEBUG
#include <crtdbg.h>
#endif

//CX^X̒`
HINSTANCE g_hinst = NULL;	//AvP[VCX^X
HACCEL g_hAccTable = NULL;	//ANZ[^nh

int WINAPI WinMain(HINSTANCE hI,HINSTANCE hP,LPSTR lpCmd,int nCmd)
{

#ifdef _DEBUG
	//[Ňos
	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF|_CRTDBG_LEAK_CHECK_DF);

	//݌o(fobOp)
	//_CrtSetBreakAlloc(1037);
#endif

	ErrMsg("[inf]LiveTV -> Start");

	MSG msg;
	INITCOMMONCONTROLSEX iccex;
	CMainWindow *pMainWnd = NULL;
	CSplashWindow *pSplashWindow = NULL;
	RECT rcMainWnd;
	HANDLE hMutex;
	HWND hW;

	if(hP) return 0;

	//////////////////////////////////////////////////////////////////////////
	//2dNh~
	hMutex = CreateMutex(NULL, TRUE, MUTEX_NAME);
	if( GetLastError() == ERROR_ALREADY_EXISTS){
		hW = FindWindow(CBASE_WINDOW_CLASS,MAINWINDOW_TITLE);
		
		if(hW != NULL){
			//EChEɖ߂
			if(IsIconic(hW) == TRUE){
				ShowWindow(hW,SW_RESTORE);
			}

			//EChEőOʂɕ\
			SetForegroundWindow(hW);
		}
		
		//~[ebNX

		CloseHandle(hMutex);
		return 0;
	}

	//COM̏s
	CoInitialize(NULL);

	//CX^X̕ۑ
	g_hinst = hI;
	
	//RRg[̏
	InitCommonControls();
	iccex.dwSize=sizeof(INITCOMMONCONTROLSEX);
	iccex.dwICC = ICC_BAR_CLASSES|ICC_INTERNET_CLASSES;
	InitCommonControlsEx(&iccex);

	//EChENX̓o^
	CBaseWnd::RegistWndClass(g_hinst);

	//XvbVEChE쐬
	pSplashWindow = new CSplashWindow;

	pSplashWindow = new CSplashWindow;
	if(pSplashWindow != NULL){

		//EChE쐬
		pSplashWindow->CreateWnd(0,WS_POPUP,0,0,320,240,NULL,NULL,g_hinst);

		//xݒ肷
		pSplashWindow->SetAlphaColor(RGB(0,16,0),200,LWA_ALPHA);
		
		ShowWindow(pSplashWindow->m_hWnd,SW_SHOW);
		UpdateWindow(pSplashWindow->m_hWnd);
	}

	//CEChE쐬
	pMainWnd = new CMainWindow;

	pMainWnd->put_SpashWindow(pSplashWindow);

	if(pMainWnd->LoadWndPos(&rcMainWnd) == FALSE){
		//fXNgbvTCY擾
		int nScrX = GetSystemMetrics(SM_CXSCREEN);
		int nScrY = GetSystemMetrics(SM_CYSCREEN);

		//EChËʒuݒ肷
		rcMainWnd.top = (nScrY - DEFAULT_WND_HEIGHT) / 2;
		rcMainWnd.bottom = rcMainWnd.top + DEFAULT_WND_HEIGHT;

		rcMainWnd.left = (nScrX - DEFAULT_WND_WIDTH) / 2;;
		rcMainWnd.right = rcMainWnd.left + DEFAULT_WND_WIDTH;
	}

	pMainWnd->CreateWnd(0,
		WS_THICKFRAME|WS_SYSMENU|WS_POPUP|WS_CLIPCHILDREN|WS_MAXIMIZEBOX|WS_MINIMIZEBOX,
		rcMainWnd.left,rcMainWnd.top,
		rcMainWnd.right - rcMainWnd.left,
		rcMainWnd.bottom - rcMainWnd.top,
		NULL,
		NULL,
		g_hinst);

	SetWindowText(pMainWnd->m_hWnd,MAINWINDOW_TITLE);
	SendMessage(pMainWnd->m_hWnd,WM_SETICON,(WPARAM)ICON_SMALL,(LPARAM)LoadIcon(g_hinst,MAKEINTRESOURCE(IDI_ICON_MAIN)));
	SendMessage(pMainWnd->m_hWnd,WM_SETICON,(WPARAM)ICON_BIG,(LPARAM)LoadIcon(g_hinst,MAKEINTRESOURCE(IDI_ICON_MAIN)));

	//\
	ShowWindow(pMainWnd->m_hWnd,SW_SHOW);
	UpdateWindow(pMainWnd->m_hWnd);

	//ANZ[^(V[gJbgL[)[h
	g_hAccTable = LoadAccelerators(g_hinst,MAKEINTRESOURCE(IDR_ACCELERATOR1));

	//XvbVEChE
	pMainWnd->put_SpashWindow(NULL);
	if(pSplashWindow != NULL){
		SendMessage(pSplashWindow->m_hWnd,WM_CLOSE,0,0);
		delete pSplashWindow;
		pSplashWindow = NULL;
	}

	//bZ[W[v
	for(;;) {
		while(PeekMessage(&msg, NULL, 0, 0,PM_REMOVE)) {
			if(msg.message == WM_QUIT) goto end_section;

			if(TranslateAccelerator(pMainWnd->m_hWnd, g_hAccTable, &msg))
				continue;

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		WaitMessage();
	}

end_section:

	ErrMsg("[inf]LiveTV -> End");

	if(pMainWnd != NULL){
		//
		PTR_DELETE(pMainWnd);
	}

	//COMI
	CoUninitialize();

	//Mutex
	if(hMutex != NULL){
		ReleaseMutex(hMutex);
		CloseHandle(hMutex);
	}

	return 0;
}

