#pragma warning(disable : 4995)

#include <windows.h>
#include <stdio.h>
#include "..\Setting\CSetting.h"
#include "ThreadSnapShot.h"
#include "..\ijpeglib\BmpToJpg.h"
#include "..\GDI\AdjustBmp.h"

extern BOOL RGB32toRGB24(BITMAPINFOHEADER *pbIn,BITMAPINFOHEADER *pbOut);

//#define TREAD_GET_BMP 1

unsigned int __stdcall ThreadSnapShot(LPVOID pPalam){
	ST_THREAD_SNAPSHOT *pInfo = (ST_THREAD_SNAPSHOT *)pPalam;
	BITMAPFILEHEADER bfh;
	BITMAPINFOHEADER *pbmi = NULL;
	BITMAPINFOHEADER *pbmiOut = NULL;
	int nBmiOut;
	
	FILE *fp;
	BOOL lRet = FALSE;
	
	if(pInfo == NULL)return 0;

#ifndef TREAD_GET_BMP
	pbmi = (BITMAPINFOHEADER *)pInfo->m_plDIB;
	pbmiOut = NULL;
#else
	//COM̏s
	CoInitialize(NULL);


	long lBufSize = 0;
	if(pInfo->m_pDtvEngine->m_pMediaViewer->GetSnapShot_BasicVideo(&lBufSize,NULL) == FALSE)
		goto end_section;
	
	pInfo->m_pDtvEngine->StopEngine();

	pbmi= (BITMAPINFOHEADER *)new char [lBufSize];
	if(pInfo->m_pDtvEngine->m_pMediaViewer->GetSnapShot_BasicVideo(&lBufSize,(long *)pbmi) == FALSE)
		goto end_section;

	pInfo->m_pDtvEngine->StartEngine(TRUE);
#endif

	if(pbmi->biBitCount == 32){
		pbmiOut = (BITMAPINFOHEADER *)new  char[sizeof( BITMAPINFOHEADER ) + pbmi->biHeight * pbmi->biWidth * 3];
		RGB32toRGB24(pbmi,pbmiOut);

		delete [] pbmi;
		pbmi = pbmiOut;
		pInfo->m_plDIB = (long *)pbmi;
	}

	if(AdjustBmp(pbmi,pInfo->m_stOutSize.cx,pInfo->m_stOutSize.cy,
		&pbmiOut,&nBmiOut) == FALSE) goto end_section;

	switch(pInfo->m_nType){
	case PTDIGI_SNAP_FMT_BMP:
		{
			fp = fopen(pInfo->m_szFileName,"wb");
			if(fp != NULL){
				
				//rbg}bvt@Cwb_
				ZeroMemory(&bfh, sizeof(BITMAPFILEHEADER));
				bfh.bfType = 'MB';
				bfh.bfSize = sizeof( bfh ) + (pbmiOut->biHeight * pbmiOut->biWidth * (pbmiOut->biBitCount/8)) + sizeof( BITMAPINFOHEADER );
				bfh.bfOffBits = sizeof( BITMAPINFOHEADER ) + sizeof( BITMAPFILEHEADER );
					
				fwrite(&bfh,sizeof(bfh),1,fp);
				fwrite(pInfo->m_plDIB,pInfo->m_lBufSize,1,fp);

				fclose(fp);

				lRet = TRUE;
			}
		}
		break;
	case PTDIGI_SNAP_FMT_JPG:
		{
			fp = fopen(pInfo->m_szFileName,"wb");

			if(pbmiOut->biBitCount == 24){
				if(fp != NULL){
					BmpToJpegSaveFile(fp, pbmiOut, pInfo->m_nQuality, 0);
					fclose(fp);
					lRet = TRUE;
				}
			}

			//delete [] pbmi;
		}
		break;
	}

end_section:


#ifdef TREAD_GET_BMP
	//COMI
	CoUninitialize();
#endif

	//mۂobt@폜
	if(pbmiOut != NULL){
		delete [] pbmiOut;
	}

	if(pInfo->m_plDIB != NULL){
		delete [] pInfo->m_plDIB;
	}

	delete pInfo;

	return 0;
}