#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "CVidPreviewDlg.h"
#include "..\DirectShowFilter\EnumFilter.h"
#include "..\resource.h"

#define DIGITV_MPEG2DEC_AUTO "I"

CVidPreviewDlg::CVidPreviewDlg(){
	m_szMpeg2Dec[0] = '\0';
	m_szMpeg2Dec[119] = '\0';
}

CVidPreviewDlg::~CVidPreviewDlg(){
}

//R}hnh
void CVidPreviewDlg::OnOK(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	
	//pX擾
	GetDlgItemText(hDlg,IDC_COMBO_MPEGDEC,&m_szMpeg2Dec[0],119);
	
	//ݒ̏ꍇ̏
	if(strcmp(m_szMpeg2Dec,DIGITV_MPEG2DEC_AUTO) == 0)
		m_szMpeg2Dec[0] = '\0';
}

void CVidPreviewDlg::OnCancel(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
}

//bZ[Wnh
int CVidPreviewDlg::OnWmInitDlg(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	m_hWnd = hDlg;
	m_hInst = (HINSTANCE)GetWindowLong(hDlg,GWL_HINSTANCE);

	CDirectShowUtil cDSUtil;
	char szMpeg2Vid[120];
	int i;

	//ݒ肷
	
	//TCYݒ肷
	SendDlgItemMessage(hDlg,IDC_COMBO_MPEGDEC,CB_INSERTSTRING,-1,(LPARAM)DIGITV_MPEG2DEC_AUTO);

	// MPEG2fR[_
	szMpeg2Vid[119] = '\0';
	if(cDSUtil.FindFilter(&MEDIATYPE_Video,&MEDIASUBTYPE_MPEG2_VIDEO)){

		for(i=0;i<cDSUtil.GetFilterCount();i++){
			if(cDSUtil.GetFilterInfo(i,NULL,&szMpeg2Vid[0],119)){
				SendDlgItemMessage(hDlg,IDC_COMBO_MPEGDEC,CB_INSERTSTRING,-1,(LPARAM)szMpeg2Vid);
			}
		}
	}

	//ڂI
	i = SendDlgItemMessage(hDlg,IDC_COMBO_MPEGDEC,CB_FINDSTRING,-1,(LPARAM)m_szMpeg2Dec);
	if(i == CB_ERR)i = 0;
	SendDlgItemMessage(hDlg,IDC_COMBO_MPEGDEC,CB_SETCURSEL,i,NULL);

	return 0;
}

int CVidPreviewDlg::OnWmCommand(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	switch(GET_WM_COMMAND_ID(wP,lP)){

	case IDOK:
		OnOK(hDlg,msg,wP,lP);
		break;

	case IDCANCEL:
		break;
	}

	return 0;
}

//bZ[Wv-W[
LRESULT CVidPreviewDlg::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

	switch (uMsg){
	case WM_COMMAND:
		return OnWmCommand(hWnd,uMsg,wParam,lParam);

	case WM_INITDIALOG:
		return OnWmInitDlg(hWnd,uMsg,wParam,lParam);

	case WM_DESTROY:
		break;
	}

	return 0;
}
