#pragma warning(disable : 4995)

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <process.h>

#include "CVidTVTunerDlg.h"
#include "..\Util\StrUtil.h"
#include "..\resource.h"

//萔̒`
#define LV_COLUMN_TVTUNER_NUMBER 0
#define LV_COLUMN_TVBRODCAST 1
#define LV_COLUMN_REMOCON_CH 2

#define WM_SCAN_FINISH (WM_USER + 100)

typedef struct _ST_THREAD_CH_SCAN{
	HANDLE m_hEventStop;
	CVidTVTunerDlg *m_pDlg;
	CDtvEngine *m_pDtvEngine;

}ST_THREAD_CH_SCAN;

unsigned int __stdcall ThreadChannelScan(LPVOID pPalam){
	ST_THREAD_CH_SCAN *pInfo = (ST_THREAD_CH_SCAN *)pPalam;
	DWORD dwChannel;
	DWORD dwSpace;
	WORD wSrvCount;
	WORD wIndex;
	WORD wSvrID;

	int nChMax;
	int nChCount;
	int nProgress;
	wchar_t *pwszName;
	char szChName[80];

	char szStr[120];
	ST_TV_INFOMATION stTVInfo;

	CProgManager *pProgManager = NULL;

	int nSignal;
	int nErrCode;
	int nRetry;
	BOOL bGetSvr;

	szStr[119] = '\0';
	szChName[79] = '\0';

	//COM̏s
	CoInitialize(NULL);

	//̃G[
	if(pInfo == NULL){nErrCode = 1;goto end_section;}
	if(pInfo->m_pDtvEngine == NULL){nErrCode = 1;goto end_section;}

	//ϐݒ肷
	pProgManager = pInfo->m_pDtvEngine->m_pProgManager;

	//`l̍ő߂
	nChMax = 0;
	for(dwSpace = 0UL ; pInfo->m_pDtvEngine->m_pBonSrcDecoder->GetSpaceName(dwSpace) ; dwSpace++){
		for(dwChannel = 0UL ; pInfo->m_pDtvEngine->m_pBonSrcDecoder->GetChannelName(dwSpace, dwChannel) ; dwChannel++){
			++nChMax;
		}
	}

	//`lXL
	nChCount = 0;
	for(dwSpace = 0UL ; pInfo->m_pDtvEngine->m_pBonSrcDecoder->GetSpaceName(dwSpace) ; dwSpace++){
		//for(dwChannel = 0UL ; pInfo->m_pDtvEngine->m_pBonSrcDecoder->GetChannelName(dwSpace, dwChannel) ; dwChannel++){
		for(dwChannel = 36UL ; pInfo->m_pDtvEngine->m_pBonSrcDecoder->GetChannelName(dwSpace, dwChannel) ; dwChannel++){
			
			//Ԃ\
			++nChCount;
			if(nChMax != 0){
				nProgress =  nChCount * 100 / nChMax; 
			}
			else{
				nProgress = 100;
			}
			
			//`l𓾂
			pwszName = pInfo->m_pDtvEngine->m_pBonSrcDecoder->GetChannelName(dwSpace,dwChannel);
			if(pwszName != NULL){
				WideCharToMultiByte(CP_ACP, 0, pwszName, -1, szChName, 79, NULL, NULL);
			}

			//Xe[^X\
			_snprintf(szStr,119,"%d%% I (%s =00.00db)",nProgress,szChName);
			pInfo->m_pDlg->SetStatus(szStr);
			
			//`lݒ肷
			pInfo->m_pDtvEngine->StopEngine();
			pInfo->m_pDtvEngine->SetChannel(dwSpace,(WORD)dwChannel);
			pInfo->m_pDtvEngine->StartEngine(FALSE);
			
			//1bҋ@
			for(nRetry=0;nRetry<20;++nRetry)
			{
				if(WaitForSingleObject(pInfo->m_hEventStop,200) != WAIT_TIMEOUT)break;

				//Mx擾
				nSignal = int (pInfo->m_pDtvEngine->m_pBonSrcDecoder->GetSignalLevel() * 100);

				ErrMsg("[inf]DTV_ChScan : %d -> %d",dwChannel,nSignal);

				//Mx\
				_snprintf(szStr,119,"%d%% I (%s = %d.%ddb)",nProgress,szChName,nSignal/100,nSignal%100);
				pInfo->m_pDlg->SetStatus(szStr);

				//M擾璆f
				if(nSignal > 0)break;
			}
			if(WaitForSingleObject(pInfo->m_hEventStop,200) != WAIT_TIMEOUT)break;

			//if(nSignal == 0)continue;
			if(nSignal <= 0)continue;

			//NIT擾
			bGetSvr = FALSE;
			nRetry = 0;
			do{
				if(WaitForSingleObject(pInfo->m_hEventStop,100) != WAIT_TIMEOUT)break;
				if(pProgManager->GetNetworkID() != 0)break;

				++nRetry;
			}while(bGetSvr == FALSE && nRetry < 60);

			//T[rX擾
			bGetSvr = FALSE;
			nRetry = 0;
			do{
				if(WaitForSingleObject(pInfo->m_hEventStop,100) != WAIT_TIMEOUT)break;
				
				wSrvCount = pProgManager->GetServiceNum();

				for(wIndex = 0U ; wIndex < wSrvCount ; wIndex++){
					
					if(pProgManager->GetServiceName(szStr, wIndex)){
						bGetSvr = TRUE;
					}
					pProgManager->GetServiceID(&wSvrID,wIndex);
					
					if(bGetSvr == TRUE){
						ZeroMemory(&stTVInfo,sizeof(stTVInfo));
						
						//ݒۑ
						strncpy(stTVInfo.szSvrName,szStr,sizeof(stTVInfo.szSvrName)-1);
						stTVInfo.lSpace		= dwSpace;
						stTVInfo.lChIdx		= dwChannel;
						stTVInfo.lSvrIdx	= wIndex;
						stTVInfo.lSvrID		= wSvrID;
						stTVInfo.IsSignal	= TRUE;
						stTVInfo.nRmCtrlKeyID = pProgManager->GetRmtID();
						stTVInfo.nNIT1		= pProgManager->GetNetworkID();
						//3ԍ = T[rXʁ~200{remote_control_key_id~10{(T[rXԍ{1)
						stTVInfo.nLogicalCh = ((pProgManager->GetRmtID() * 10) + (wIndex+1)) * 10;

						pInfo->m_pDlg->AddInfo(&stTVInfo);
						pInfo->m_pDlg->AddInfoToDB(&stTVInfo);

						ErrMsg("[inf]DTV_ChScan : %d-%d : (RmtID=%d SvrID=%d Ch=%03d)%s",dwChannel,wIndex,stTVInfo.nRmCtrlKeyID,wSvrID,stTVInfo.nLogicalCh,szStr);
					}
				}

				++nRetry;

			}while(bGetSvr == FALSE && nRetry < 60);
		
		}//for(dwChannel = 0UL ; pInfo->m_pDtvEngine->m_pBonSrcDecoder->GetChannelName(dwSpace, dwChannel) ; dwChannel++){
	
	}//for(dwSpace = 0UL ; pInfo->m_pDtvEngine->m_pBonSrcDecoder->GetSpaceName(dwSpace) ; dwSpace++){

	//G[R[hݒ肷
	nErrCode = 0;

end_section:
	//IbZ[W𓊂
	PostMessage(pInfo->m_pDlg->m_hWnd,WM_SCAN_FINISH,nErrCode,NULL);

	if(pInfo->m_hEventStop != NULL){
		CloseHandle(pInfo->m_hEventStop);
	}

	delete pInfo;

	//COMI
	CoUninitialize();

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//RXgN^/fRXgN^
CVidTVTunerDlg::CVidTVTunerDlg(){
	m_pDBTvInfo = NULL;
	m_pDtvEngine = NULL;
	m_hEventStop = NULL;
	m_hThreadChScan = NULL;
}

CVidTVTunerDlg::~CVidTVTunerDlg(){
	if(m_hEventStop != NULL){
		CloseHandle(m_hEventStop);
		m_hEventStop = NULL;
	}
}

//////////////////////////////////////////////////////////////////////////////
//o֐
BOOL CVidTVTunerDlg::AddInfo(ST_TV_INFOMATION *pInfo){
	char szStr[120];
	char szChName[120];
	int nIdx;
	
	szChName[119] = '\0';

	//`l쐬
	if(m_pDtvEngine == NULL){
		_snprintf(szStr,119,"%d-%d",pInfo->lChIdx,pInfo->lSvrIdx);
	}
	else{
		wchar_t *pwszName;
		pwszName = m_pDtvEngine->m_pBonSrcDecoder->GetChannelName(pInfo->lSpace,pInfo->lChIdx);
		if(pwszName != NULL){
			WideCharToMultiByte(CP_ACP, 0, pwszName, -1, szChName, 119, NULL, NULL);
		}
		_snprintf(szStr,119,"%s-%d",szChName,pInfo->lSvrIdx);
	}
	
	//`lݒ肷
	nIdx = m_ListView.InsertItem(szStr,0xffff);

	//ǖݒ肷
	m_ListView.SetItemText(pInfo->szSvrName,nIdx,LV_COLUMN_TVBRODCAST);

	//`FbN{bNXݒ肷
	m_ListView.SetCheckState(nIdx,pInfo->IsSignal);

	return TRUE;
}

BOOL CVidTVTunerDlg::AddInfoToDB(ST_TV_INFOMATION *pInfo){
	if(m_pDBTvInfo == NULL)return FALSE;

	//dĂ`lmF
	ST_TV_INFOMATION stInfo;
	int i,nCount;

	m_pDBTvInfo->GetCount(&nCount);
	for(i=0;i<nCount;++i){
		m_pDBTvInfo->GetInfoIdx(i,&stInfo,sizeof(ST_TV_INFOMATION));
		if(stInfo.nLogicalCh == pInfo->nLogicalCh){
			pInfo->nLogicalCh += 1;
			i = 0;//ēx`FbNs
		}
	}

	return m_pDBTvInfo->Add(pInfo,sizeof(ST_TV_INFOMATION));
}

void CVidTVTunerDlg::SetStatus(char *pszStr){
	SetDlgItemText(m_hWnd,IDC_STATIC_STATUS,pszStr);
}

//R}hnh
void CVidTVTunerDlg::OnOK(void){
	int nCount;
	int i;
	ST_TV_INFOMATION stInfo;

	if(m_hThreadChScan != NULL)return;

	//M̗L̐ݒs
	nCount = m_ListView.GetItemCount();
	for(i=0;i<nCount;++i){
		m_pDBTvInfo->GetInfoIdx(i,&stInfo,sizeof(ST_TV_INFOMATION));
		stInfo.IsSignal = m_ListView.GetCheckState(i);
		m_pDBTvInfo->SetInfoIdx(i,&stInfo,sizeof(ST_TV_INFOMATION));
	}

	EndDialog(m_hWnd,IDOK);
}

void CVidTVTunerDlg::OnCancel(void){
	if(m_hThreadChScan != NULL)return;

	EndDialog(m_hWnd,IDCANCEL);
}

void CVidTVTunerDlg::OnBtnStart(void){

	ST_THREAD_CH_SCAN *pInfo;

	//Cxg쐬
	if(m_hEventStop == NULL){
		m_hEventStop = CreateEvent(NULL,TRUE,FALSE,NULL);
	}

	//{^̏Ԃݒ肷
	EnableWindow(GetDlgItem(m_hWnd,IDC_LIST_BROADCAST),FALSE);
	EnableWindow(GetDlgItem(m_hWnd,IDC_BTN_START),FALSE);
	EnableWindow(GetDlgItem(m_hWnd,IDC_BTN_STOP),TRUE);
	EnableWindow(GetDlgItem(m_hWnd,IDOK),FALSE);

	//DB
	m_pDBTvInfo->ClearAllData();
	while(m_ListView.GetItemCount() > 0){
		m_ListView.DeleteItem(0);
	}

	//CxgZbg
	ResetEvent(m_hEventStop);

	//Xbhp\̂쐬
	pInfo = new ST_THREAD_CH_SCAN;
	ZeroMemory(pInfo,sizeof(ST_THREAD_CH_SCAN));

	pInfo->m_pDlg = this;
	pInfo->m_pDtvEngine = m_pDtvEngine;

	::DuplicateHandle(::GetCurrentProcess(),m_hEventStop, 
			::GetCurrentProcess(), &pInfo->m_hEventStop, 
			0, FALSE, DUPLICATE_SAME_ACCESS);

	m_hThreadChScan = (HANDLE)_beginthreadex(NULL,0,&ThreadChannelScan,pInfo,0,NULL);
}

void CVidTVTunerDlg::OnBtnStop(void){
	if(m_hEventStop == NULL)return;

	SetEvent(m_hEventStop);

	//{^̏Ԃݒ肷
	EnableWindow(GetDlgItem(m_hWnd,IDC_BTN_START),FALSE);
	EnableWindow(GetDlgItem(m_hWnd,IDC_BTN_STOP),FALSE);
	EnableWindow(GetDlgItem(m_hWnd,IDOK),FALSE);
}

//////////////////////////////////////////////////////////////////////////////
//bZ[Wnh
int CVidTVTunerDlg::OnWmInitDlg(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	DWORD dwExStyle;

	int nCount;
	int i;
	ST_TV_INFOMATION stInfo;

	//EChȄ擾
	m_hWnd = hDlg;
	m_hInst = (HINSTANCE)GetWindowLong(hDlg,GWL_HINSTANCE);

	//Xgr[ݒ肷
	m_ListView.m_hWnd = GetDlgItem(hDlg,IDC_LIST_BROADCAST);
	m_ListView.m_hWParent = m_hWnd;
	m_ListView.SetSubClassListView();

	m_ListView.InsertColumn(60,		LV_COLUMN_TVTUNER_NUMBER,	"");
	m_ListView.InsertColumn(180,	LV_COLUMN_TVBRODCAST,		"ǖ");

	//X^Cݒ肷
	dwExStyle = m_ListView.GetExtendedListViewStyle();
	dwExStyle = dwExStyle | LVS_EX_CHECKBOXES|LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES;
	m_ListView.SetExtendedListViewStyle(dwExStyle);

	//f[^ǉ
	m_pDBTvInfo->GetCount(&nCount);
	for(i=0;i<nCount;++i){
		m_pDBTvInfo->GetInfoIdx(i,&stInfo,sizeof(ST_TV_INFOMATION));
		AddInfo(&stInfo);
	}

	//{^̏Ԃݒ肷
	EnableWindow(GetDlgItem(m_hWnd,IDC_BTN_STOP),FALSE);

	return 0;
}

int CVidTVTunerDlg::OnWmNotify(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	int idCtrl = wP;
	LPNMHDR pnmh = (LPNMHDR)lP;

	switch(idCtrl){
	case IDC_LIST_BROADCAST:
		switch(pnmh->code){
		case NM_DBLCLK:
			//OnNmDbClk_ListBroadCast(lP);
			break;
		}
		break;
	}

	return 0;
}

int CVidTVTunerDlg::OnWmScanFinish(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	
	ErrMsg("[Inf]CVidTVTunerDlg::OnWmScanFinish");

	if(m_hThreadChScan != NULL){
		WaitForSingleObject(m_hThreadChScan,10000);
		CloseHandle(m_hThreadChScan);
		m_hThreadChScan = NULL;
	}

	//f[^ƃXg\[g
	m_pDBTvInfo->Sort();

	//f[^ǉ
	while(m_ListView.GetItemCount() > 0){
		m_ListView.DeleteItem(0);
	}

	int i,nCount;
	ST_TV_INFOMATION stInfo;
	m_pDBTvInfo->GetCount(&nCount);
	for(i=0;i<nCount;++i){
		m_pDBTvInfo->GetInfoIdx(i,&stInfo,sizeof(ST_TV_INFOMATION));
		AddInfo(&stInfo);
	}

	//{^̏Ԃݒ肷
	EnableWindow(GetDlgItem(m_hWnd,IDC_LIST_BROADCAST),TRUE);
	EnableWindow(GetDlgItem(m_hWnd,IDC_BTN_START),TRUE);
	EnableWindow(GetDlgItem(m_hWnd,IDC_BTN_STOP),FALSE);
	EnableWindow(GetDlgItem(m_hWnd,IDOK),TRUE);

	//Ԃݒ肷
	SetStatus("");

	return 0;
}

int CVidTVTunerDlg::OnWmCommand(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){

	switch(GET_WM_COMMAND_ID(wP,lP)){
	case IDOK:
		OnOK();
		break;
	case IDCANCEL:
		OnCancel();
		break;
	case IDC_BTN_START:
		OnBtnStart();
		break;
	case IDC_BTN_STOP:
		OnBtnStop();
		break;
	}

	return 0;
}

//bZ[Wv-W[
LRESULT CVidTVTunerDlg::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

	switch (uMsg){
	case WM_COMMAND:
		return OnWmCommand(hWnd,uMsg,wParam,lParam);

	case WM_INITDIALOG:
		return OnWmInitDlg(hWnd,uMsg,wParam,lParam);

	case WM_SCAN_FINISH:
		return OnWmScanFinish(hWnd,uMsg,wParam,lParam);


	case WM_NOTIFY:
		return OnWmNotify(hWnd,uMsg,wParam,lParam);
	}

	return 0;
}
